Name: rsnapshot
Summary: Local and remote filesystem snapshot utility
Version: 1.3.1
Release: 27%{?dist}
BuildArch: noarch
License: GPL-2.0-or-later
Group: Applications/System
URL: https://rsnapshot.org/
Packager: Simon Matter <simon.matter@invoca.ch>
Vendor: Invoca Systems
Distribution: Invoca Linux Server
Source0: https://rsnapshot.org/downloads/%{name}-%{version}.tar.gz
Source1: rsync_rsh_wrapper
Source2: %{name}.logrotate
Patch0: rsnapshot.patch
Patch1: rsnapshot-1.3.1-rsync_rsh_wrapper.patch
Patch2: rsnapshot-1.3.1-src_is_root.patch
Patch3: rsnapshot-1.3.1-ignore_lock_in_test.patch
Patch4: rsnapshot-1.3.1-log_pid.patch
Patch5: rsnapshot-1.3.1-delete_foreign_lock.patch
Patch6: rsnapshot-1.3.1-rsync_3.x.x_one_fs.patch
Patch7: rsnapshot-1.3.1-pod2man.patch
Patch8: rsnapshot-1.3.1-common_delete_dir.patch
Patch9: rsnapshot-1.3.1-remove_lock_in_sync.patch
Requires: perl, rsyncxl >= 3.2.3
AutoReqProv: no
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
Rsnapshot is a filesystem snapshot utility for making backups of local
and remote systems. Using rsync and hard links, it is possible to keep
multiple, full backups instantly available. The disk space required is
just a little more than the space of one full backup, plus incrementals.

%prep
%setup -q
%patch0 -p0
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%{__perl} -pi -e "s|interval|retain|g" rsnapshot.conf.default.in
%{__perl} -pi -e "s|retain\t|retain\t\t|g" rsnapshot.conf.default.in
%{__perl} -pi -e "s|/usr/bin/env\ perl|%{__perl}\n#|g" utils/rsnapreport.pl
%{__perl} -pi -e "s|rsnapreport\.pl|rsnapreport|g" utils/rsnapreport.pl
%{__perl} -pi -e "s|StrictHostKeyChecking=no|StrictHostKeyChecking=no -o CheckHostIP=no|g" rsnapshot.conf.default.in rsnapshot-program.pl
> rsnapshot-preamble.pl

%build
%configure \
  --with-perl="%{__perl}" \
  --with-rsync="%{_bindir}/rsync" \
  --with-ssh="%{_bindir}/ssh" \
  --with-logger="%{_bindir}/logger" \
  --with-du="%{_bindir}/du"
%{__make}

# change config to use rsyncxl instead of rsync
%{__perl} -pi -e "s|%{_bindir}/rsync$|%{_bindir}/rsyncxl|g" %{name} %{name}.conf.default

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%{__install} -d %{buildroot}/%{_bindir}
%{__install} -d %{buildroot}/%{_mandir}/man1
%{__install} -d %{buildroot}/%{_sysconfdir}/logrotate.d

%{__install} -m 0755 -p %{name} %{buildroot}/%{_bindir}/
%{__install} -m 0755 -p %{name}-diff %{buildroot}/%{_bindir}/
%{__install} -m 0755 -p utils/rsnapreport.pl %{buildroot}/%{_bindir}/rsnapreport
%{__install} -m 0755 -p %{SOURCE1} %{buildroot}/%{_bindir}/

%{__install} -m 0644 -p %{name}*.1 %{buildroot}/%{_mandir}/man1/

%{__install} -m 0644 -p %{name}.conf.default %{buildroot}/%{_sysconfdir}/
%{__install} -m 0600 -p %{name}.conf.default %{buildroot}/%{_sysconfdir}/%{name}.conf

%{__install} -m 0644 -p %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING ChangeLog README INSTALL TODO
%doc docs/Upgrading_from_1.1 docs/HOWTOs/%{name}-HOWTO.en.html
%{_sysconfdir}/%{name}.conf.default
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_bindir}/%{name}
%{_bindir}/%{name}-diff
%{_bindir}/rsnapreport
%{_bindir}/rsync_rsh_wrapper
%{_mandir}/man1/%{name}*.1*

%changelog
* Tue Feb 11 2025 Simon Matter <simon.matter@invoca.ch> 1.3.1-27
- remove aes128-cbc from wrapper patch

* Thu Dec 07 2023 Simon Matter <simon.matter@invoca.ch> 1.3.1-26
- set SSH option CheckHostIP=no only for EL < 9

* Thu Nov 23 2023 Simon Matter <simon.matter@invoca.ch> 1.3.1-25
- change to SPDX license tag
- change fast cipher from arcfour to aes128-cbc

* Mon Nov 01 2021 Simon Matter <simon.matter@invoca.ch> 1.3.1-24
- add patch to remove lock during explicit sync

* Thu Jul 15 2021 Simon Matter <simon.matter@invoca.ch> 1.3.1-23
- add patch to use a common .delete/ directory

* Wed Jul 08 2020 Simon Matter <simon.matter@invoca.ch> 1.3.1-22
- fix changes for upcoming rsyncxl >= 3.2.3

* Tue Jun 30 2020 Simon Matter <simon.matter@invoca.ch> 1.3.1-21
- add requirement and options for rsyncxl >= 3.2.2

* Wed Mar 11 2020 Simon Matter <simon.matter@invoca.ch> 1.3.1-20
- change config to use rsyncxl instead of rsync

* Fri Mar 22 2019 Simon Matter <simon.matter@invoca.ch> 1.3.1-18
- improve help message of rsync_rsh_wrapper

* Tue Dec 16 2014 Simon Matter <simon.matter@invoca.ch> 1.3.1-17
- add pod2man patch to allow build on el7

* Fri Oct 25 2013 Simon Matter <simon.matter@invoca.ch> 1.3.1-16
- improve speed of rsync_rsh_wrapper

* Sat Jan 05 2013 Simon Matter <simon.matter@invoca.ch> 1.3.1-15
- fix rsync_rsh_wrapper

* Sat Jan 05 2013 Simon Matter <simon.matter@invoca.ch> 1.3.1-14
- improve rsync_rsh_wrapper

* Sat Jan 05 2013 Simon Matter <simon.matter@invoca.ch> 1.3.1-13
- update rsync_rsh_wrapper to allow ssh_args

* Thu Sep 08 2011 Simon Matter <simon.matter@invoca.ch> 1.3.1-12
- add patch to fix one_fs issue with rsync-3.x.x

* Fri Jul 29 2011 Simon Matter <simon.matter@invoca.ch> 1.3.1-11
- rediff patches for EL6

* Fri Apr 15 2011 Simon Matter <simon.matter@invoca.ch> 1.3.1-10
- mass rebuild

* Thu Oct 14 2010 Simon Matter <simon.matter@invoca.ch> 1.3.1-9
- update delete_foreign_lock patch

* Wed Oct 13 2010 Simon Matter <simon.matter@invoca.ch> 1.3.1-8
- update delete_foreign_lock patch

* Mon Oct 11 2010 Simon Matter <simon.matter@invoca.ch> 1.3.1-7
- add delete_foreign_lock patch

* Mon Jan 04 2010 Simon Matter <simon.matter@invoca.ch> 1.3.1-6
- add log_pid patch

* Thu Nov 05 2009 Simon Matter <simon.matter@invoca.ch> 1.3.1-5
- add logrotate script

* Tue Aug 18 2009 Simon Matter <simon.matter@invoca.ch> 1.3.1-4
- add ignore_lock_in_test patch

* Thu Aug 06 2009 Simon Matter <simon.matter@invoca.ch> 1.3.1-3
- use empty rsnapshot-preamble.pl file

* Thu Sep 18 2008 Simon Matter <simon.matter@invoca.ch> 1.3.1-2
- change interval to retain in default config

* Mon Sep 15 2008 Simon Matter <simon.matter@invoca.ch> 1.3.1-1
- upgrade to 1.3.1

* Wed May 14 2008 Simon Matter <simon.matter@invoca.ch> 1.3.0-5
- add src_is_root patch

* Fri Oct 19 2007 Simon Matter <simon.matter@invoca.ch> 1.3.0-4
- add some more changes to the rsync_rsh_wrapper patch

* Thu Oct 18 2007 Simon Matter <simon.matter@invoca.ch> 1.3.0-3
- fix rsync_rsh_wrapper patch

* Wed Oct 17 2007 Simon Matter <simon.matter@invoca.ch> 1.3.0-2
- use blocking IO with rsync_rsh_wrapper

* Tue Oct 16 2007 Simon Matter <simon.matter@invoca.ch> 1.3.0-1
- update to 1.3.0
- add rsync_rsh_wrapper

* Wed Jan 18 2006 Simon Matter <simon.matter@invoca.ch> 1.0.5-3rsh
- add rsync_args patch

* Sun Jan 01 2006 Simon Matter <simon.matter@invoca.ch> 1.0.5-2rsh
- fix rsh patch to work with rsync if ssh is the default transport

* Tue Jul 19 2005 Simon Matter <simon.matter@invoca.ch>
- change Copyright to License in specfile

* Fri Nov 14 2003 Simon Matter <simon.matter@invoca.ch>
- added rsh patch

* Wed Nov 05 2003 Nathan Rosenquist <nathan@rsnapshot.org>
- Removed fileutils dependency, added verification info

* Tue Nov 04 2003 Nathan Rosenquist <rsnapshot@scubaninja.com>
- fixed anonymous rsync error

* Thu Oct 30 2003 Nathan Rosenquist <rsnapshot@scubaninja.com>
- update to 1.0.3

* Tue Oct 28 2003 Carl Wilhelm Soderstrom <chrome@real-time.com>
- created spec file
